/*
	Cleanup & formalization of JXLResponder by Thomas Burleson @ Universal Mind.
	
	Created by Jesse R. Warden a.k.a. "JesterXL"
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	http://www.universalmind.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/
*/
package com.jxl.cairngorm
{
	import flash.net.Responder;
	
	import mx.rpc.events.ResultEvent;
	import mx.rpc.events.FaultEvent;
	
	import mx.rpc.IResponder;
	
	public class JXLResponder implements mx.rpc.IResponder
	{
		
		public var resultFunction:Function;
		public var faultFunction:Function;
		
		private var responder:*;
		
		public function JXLResponder(p_result:Function, p_fault:Function)
		{
			resultFunction = p_result;
			faultFunction = p_fault;
			responder = new flash.net.Responder(result, fault);	
		}
		
		public function result( event : Object ) : void
		{
			if(resultFunction != null) resultFunction.call(this, event);
		}
		
		public function fault( event : Object ) : void
		{
			if(faultFunction != null) faultFunction.call(this, event);
		}
		
		public function clone():JXLResponder
		{
			return new JXLResponder(resultFunction, faultFunction);	
		}
	}
}